# @author Eric Dürr


require "lppP6/version"
require "Dish.rb"



class DishImpact < Dish 

    include Comparable

    attr_reader :name, :grams, :foodList, :e_fp, :n_fp

    def initialize(name, foods ,grams)
        super(name, foods ,grams)
        nutritional_footprints
    end
    def dailygei
        current = @foodList.head
        total = 0 
        count = 0  
        while current
            total += (current.value.gei * @grams[count])
            count += 1
            current = current.next
        end
        total
    end
    def terrainTotal
        current = @foodList.head
        total = 0 
        count = 0  
        while current
            total += (current.value.terrain * @grams[count])
            count += 1
            current = current.next
        end
        total
    end
    
    def geiMean
        current = @foodList.head
        total = 0 
        count = 0  
        while current
            total += (current.value.gei * @grams[count])
            count += 1
            current = current.next
        end
        total/foodList.length
    end


    def nutritional_footprints
        @n_fp = 0
            if energyMean < 670 then 
                @n_fp = 1 
            elsif energyMean > 830 then 
                @n_fp = 3 
            else 
                @n_fp = 2 
            end
        
        @e_fp = 0 
            if dailygei < 800 then 
                @e_fp = 1 
            elsif dailygei > 1200 then 
                @e_fp = 3 
            else 
                @e_fp = 2 
            end
        
    end   

    def to_s
        "(: #{@name} : gei [#{dailygei}] | terrain [#{terrainTotal}] :)"
    end

    def <=>(other)
        return nil unless other.instance_of? DishImpact
        
        terrainTotal + dailygei <=> other.terrainTotal + other.dailygei
    end
end