# @author Eric Dürr


require "lppP6/version"
require "DishImpact.rb"


class Menu
    include Comparable, Enumerable

    attr_reader :name, :dishes, :prices 

    def initialize (name, dishes, prices)
        @name = name
        @dishes, @prices = dishes, prices
    end


    # ---- sobrecargas ---
    def <=>(other)
        return nil unless other.instance_of? Menu
        total_impact = 0
        total_price = 0
        other_impact = 0
        other_price = 0
              dishes.each { | dish | total_impact += (dish.terrainTotal + dish.dailygei) }
        other.dishes.each { | dish | other_impact += (dish.terrainTotal + dish.dailygei) }
              prices.each { | price | total_price += price }
        other.prices.each { | price | other_price += price }
        total_impact + total_price <=> other_impact + other_price   
    end

end